local guiPos = {
	{
		884.55160522461,
		55.875635147095
	},
	[21]={20,(21-2)*29+95},
	[22]={320,(21-2)*29+95}
}

local numberBars = 20

for i = 2,numberBars do
	guiPos[i] = {20,(i-2)*29+95}
end
powergui = {}
powergui.rightdown = false
powergui.debugmode = false
guiStats = {}
local gui = false
guiVisible = true
fullRefresh = false
local barId = 1
local typeStack = {}
local guiDim = {
	{500,700},
	[21]={200,50},
	[22]={200 ,50},
}
for i = 2,numberBars do
    guiDim[i] = {180,24}
end

local context = UI.CreateContext("HUD")

-- Because it's currently impossible to destroy frames, we keep a reservoir of buff bars around. Buff bars work as a single unified whole, so once they're created, we can just call their "set" function.
local activeBuffBars = {}
local zombieBuffBars = {}
for i = 1,numberBars do
	local bar
	if i == 1 then
	    bar = UI.CreateFrame("Frame","window",context)
		bar.riftwindow = UI.CreateFrame("RiftWindow","window",bar)
		bar.riftwindow:SetPoint(0,0,bar,0,0.05)
		bar.riftwindow:SetPoint(1,1,bar,1,1)
		bar.riftwindow:SetLayer(-4)
		--bar.riftwindow:SetController("border")
		bar.riftwindow.index = 1
		bar.riftwindow:SetMouseMasking("limited")
	else
	    bar = UI.CreateFrame("Frame", "Bar", context)
	end

	bar.index = i

	if i == 1 then bar:SetPoint(0,0, UIParent, 0,0,guiPos[bar.index][1],guiPos[bar.index][2]) end

	bar:SetMouseMasking("limited")
	if i > 1 and not (i == 19) then
		bar.inputBarId = UI.CreateFrame("Frame", "Input", bar)
		bar.inputBarId:SetPoint(0,0,bar,0,0)
		bar.inputBarId:SetPoint(1,1,bar,1,1)
		bar.inputBarId:SetBackgroundColor(1,1,1)
		bar:SetPoint(0,0, activeBuffBars[1], 0,0,guiPos[bar.index][1],guiPos[bar.index][2])
		bar:SetLayer(1)
		bar.inputText = UI.CreateFrame("Text","inputText",bar)
		bar.inputTextLabel = UI.CreateFrame("Text","inputText",bar)
		bar.inputTextLabel:SetFontSize(22)
		bar.inputText:SetFontSize(22)
		if i == 2 then bar.inputTextLabel:SetText("BarId") end
		bar.inputTextLabel:SetPoint(0,0,bar,1,0)
		bar.inputText:SetPoint(0,0,bar.inputBarId,.1,0,0,0)
		bar.inputTextLabel:SetFontColor(0,0,0)
		bar.inputText:SetLayer(2)
	elseif i == 19 then
		bar.inputBarId = UI.CreateFrame("RiftTextfield", "Input", bar)
		bar.inputBarId:SetPoint(0,0,bar,0,0)
		bar.inputBarId:SetPoint(1,1,bar,1,1)
		bar.inputBarId:SetBackgroundColor(1,.27,0)
		--bar.inputBarId:SetFo(1,0.27,0)
		bar:SetPoint(0,0, activeBuffBars[1], 0,0,guiPos[bar.index][1],guiPos[bar.index][2])
		bar:SetLayer(1)
		bar.inputText = UI.CreateFrame("Text","inputText",bar)
		bar.inputTextLabel = UI.CreateFrame("Text","inputText",bar)
		bar.inputTextLabel:SetFontSize(22)
		bar.inputText:SetFontSize(22)
		if i == 2 then bar.inputTextLabel:SetText("BarId") end
		bar.inputTextLabel:SetPoint(0,0,bar,1,0)
		bar.inputText:SetPoint(0,0,bar.inputBarId,.1,0,0,0)
		bar.inputTextLabel:SetFontColor(0,0,0)
		bar.inputText:SetLayer(2)

	end
	bar:SetWidth(guiDim[i][1])
	bar:SetHeight(guiDim[i][2])

	if i == 1 then
		--bar:SetBackgroundColor(0.2, 0.2, 0.6)
		bar:SetLayer(0)
	end
	if not gui then bar:SetVisible(false)
	else bar:SetVisible(true)
	end

	function bar:Set(time)
 		if self.inputText then self.inputText:SetFontColor(0,0,0) end
 		if self.inputBarID then self.inputBarId:SetBackgroundColor(1,1,1) end
		if self.index == 2 then
		    self.inputText:SetText(" " .. barId)
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 3 then
			self.inputTextLabel:SetText("iconAlpha")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["iconAlpha"] then
				self.inputText:SetText("" .. barStats[role][barId]["iconAlpha"])
			else
				self.inputText:SetText("" .. barAlpha)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 4 then
			self.inputTextLabel:SetText("stackAlpha")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["stackAlpha"] then
				self.inputText:SetText("" .. barStats[role][barId]["stackAlpha"])
			else
				self.inputText:SetText("" .. 1)
			end
		elseif self.index == 5 then
			self.inputTextLabel:SetText("timerAlpha")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["timerAlpha"] then
				self.inputText:SetText("" .. barStats[role][barId]["timerAlpha"])
			else
				self.inputText:SetText("" .. 1)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 6 then
			self.inputTextLabel:SetText("StackFontColor")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["stackFontColor"] then
				self.inputText:SetText("" .. barStats[role][barId]["stackFontColor"][1] .. " " ..barStats[role][barId]["stackFontColor"][2] .. " " .. barStats[role][barId]["stackFontColor"][3] )
			else
				self.inputText:SetText("1 .07 .58")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 7 then
			self.inputTextLabel:SetText("TimerFontColor")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["timerFontColor"] then
				self.inputText:SetText("" .. barStats[role][barId]["timerFontColor"][1] .. " " ..barStats[role][barId]["timerFontColor"][2] .. " " .. barStats[role][barId]["timerFontColor"][3] )
			else
				self.inputText:SetText("0 0 0")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 8 then
			self.inputTextLabel:SetText("StackFontSize")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["stackFontSize"] then
				self.inputText:SetText("" .. barStats[role][barId]["stackFontSize"])
			else
				self.inputText:SetText("" .. 32)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 9 then
			self.inputTextLabel:SetText("TimerFontSize")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["timerFontSize"] then
				self.inputText:SetText("" .. barStats[role][barId]["timerFontSize"])
			else
				self.inputText:SetText("" .. 18)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 10 then
			self.inputTextLabel:SetText("barWidth")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["lBarWidth"] then
				self.inputText:SetText("" .. barStats[role][barId]["lBarWidth"])
			else
				self.inputText:SetText("" .. barWidth)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 11 then
			self.inputTextLabel:SetText("barHeight")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["lBarHeight"] then
				self.inputText:SetText("" .. barStats[role][barId]["lBarHeight"])
			else
				self.inputText:SetText("" .. barHeight)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 12 then
			self.inputTextLabel:SetText("TrackAbsence")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["trackAbsence"] then
				self.inputText:SetText("" .. "yes")
			else
				self.inputText:SetText("" .. "no")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 13 then
			self.inputTextLabel:SetText("isTarget")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["isTarget"] then
				self.inputText:SetText("" .. "yes")
			else
				self.inputText:SetText("" .. "no")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 14 then
			self.inputTextLabel:SetText("vertical Bar")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["vBar"] then
				self.inputText:SetText("yes")
			else
				self.inputText:SetText("no")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 15 then
			self.inputTextLabel:SetText("horizontal Bar")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["hBar"] then
				self.inputText:SetText("yes")
			else
				self.inputText:SetText("no")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 16 then
			self.inputTextLabel:SetText("Track Cooldown")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["cooldown"] then
				self.inputText:SetText("yes")
			else
				self.inputText:SetText("no")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 17 then
			self.inputTextLabel:SetText("bar Position x")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barPosx[role][barId] then
				self.inputText:SetText("" .. barPosx[role][barId])
			else
				self.inputText:SetText("" .. 0)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 18 then
			self.inputTextLabel:SetText("bar Position y")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barPosy[role][barId] then
				self.inputText:SetText("" .. barPosy[role][barId])
			else
				self.inputText:SetText("" .. 0)
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 19 then
			self.inputTextLabel:SetText("Name")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if powerBuffs[role][barId] then
				--self.inputText:SetText("" .. powerBuffs[role][barId])
				self.inputBarId:SetText("" .. powerBuffs[role][barId])

			else
				--self.inputText:SetText("")
				selfinputBarId:SetText("")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		elseif self.index == 20 then
			self.inputTextLabel:SetText("bar Color")
			self.inputTextLabel:SetWidth(self.inputTextLabel:GetFullWidth())
			if barStats[role][barId]["barColor"] then
				self.inputText:SetText("" .. barStats[role][barId]["barColor"][1] .. " " ..barStats[role][barId]["barColor"][2] .. " " .. barStats[role][barId]["barColor"][3] )
			else
				self.inputText:SetText("0.2 0.2 0.6")
			end
			self.inputText:SetWidth(self.inputText:GetFullWidth())
		end


		if guiPos[self.index][1] and guiPos[self.index][2] and self.index > 1 then
			self:SetLayer(1)
			self:SetPoint(0,0,activeBuffBars[1] , 0,0, guiPos[self.index][1],guiPos[self.index][2])
			bar:SetWidth(guiDim[self.index][1])
			bar:SetHeight(guiDim[self.index][2])
		elseif self.index == 1 then
			self:SetPoint(0,0, UIParent, 0,0,guiPos[self.index][1],guiPos[self.index][2])
		else
			guiPos[self.index][1] = 0
			guiPos[self.index][2] = 0
		end

	end


	function bar:Tick(time)
		if self.index > 0 and not (self.index == 19) then
			function bar.Event:KeyDown(button)
				if string.byte(button) == 13 then
					self:SetKeyFocus(false)
				elseif string.byte(button) == 8 then
					table.remove(typeStack,table.maxn(typeStack))
				end
				if button:match("[%d.a-zA-Z ]") then
					table.insert(typeStack,button)
				end
				local typed = ""
				for i,v in ipairs(typeStack) do
					typed = typed .. v
				end
				if self.inputText and not (self.index == 19) then
				    self.inputText:SetText(typed)
					self.inputText:SetWidth(self.inputText:GetFullWidth())
				end
			end
			function bar.Event:KeyFocusGain()
				typeStack = {}
			end
			function bar.Event:KeyFocusLoss()
				local typed = ""
				for i,v in ipairs(typeStack) do
					typed = typed .. v
				end
				if not (typed == "") then
					if self.index == 2 then
						barId = tonumber(typed)
						if debugmode then print(barId)end
						if not barStats[role][barId] then
						    barStats[role][barId] = {}
						end
						if not powerBuffs[role][barId] then
						    powerBuffs[role][barId] = " "
						end
						if not barPosx[role][barId] then
						     barPosx[role][barId] = 0
						end
						if not barPosy[role][barId] then
						     barPosy[role][barId] = 0
						end

					elseif self.index == 3 then
						 barStats[role][barId]["iconAlpha"] = tonumber(typed)
					elseif self.index == 4 then
						 barStats[role][barId]["stackAlpha"] = tonumber(typed)
					elseif self.index == 5 then
						 barStats[role][barId]["timerAlpha"] = tonumber(typed)
					elseif self.index == 6 then
						local rgb = {}
						for token in string.gmatch(typed,"[^ ]+") do
							table.insert(rgb,tonumber(token))
						end
						if table.maxn(rgb) == 3 then
						    barStats[role][barId]["StackFontColor"] = rgb
						end
					elseif self.index == 7 then
						local rgb = {}
						for token in string.gmatch(typed,"[^ ]+") do
							table.insert(rgb,tonumber(token))
						end
						if table.maxn(rgb) == 3 then
						    barStats[role][barId]["timerFontColor"] = rgb
						end
					elseif self.index == 8 then
						 barStats[role][barId]["stackFontSize"] = tonumber(typed)
					elseif self.index == 9 then
						 barStats[role][barId]["timerFontSize"] = tonumber(typed)
					elseif self.index == 10 then
						 barStats[role][barId]["lBarWidth"] = tonumber(typed)
					elseif self.index == 11 then
						 barStats[role][barId]["lBarHeight"] = tonumber(typed)
					elseif self.index == 12 then
						 if typed == "YES" then
						 	barStats[role][barId]["trackAbsence"] = true
						 else
						 	barStats[role][barId]["trackAbsence"] = nil
						 end
					elseif self.index == 13 then
						 if typed == "YES" then
						 	barStats[role][barId]["isTarget"] = true
						 else
						 	barStats[role][barId]["isTarget"] = nil
						 end
					elseif self.index == 14 then
						 if typed == "YES" then
						 	barStats[role][barId]["vBar"] = true
						 else
						 	barStats[role][barId]["vBar"] = nil
						 end
					elseif self.index == 15 then
						 if typed == "YES" then
						 	barStats[role][barId]["hBar"] = true
						 else
						 	barStats[role][barId]["hBar"] = nil
						 end
					elseif self.index == 16 then
						 if typed == "YES" then
						 	barStats[role][barId]["cooldown"] = true
						 else
						 	barStats[role][barId]["cooldown"] = nil
						 end
					elseif self.index == 17 then
						if typed:match("%d+") then
						 	 barPosx[role][barId] = tonumber(typed:match("%d+"))
						 end
						self.inputText:SetWidth(self.inputText:GetFullWidth())
					elseif self.index == 18 then
						if typed:match("%d+") then
						    barPosy[role][barId] = tonumber(typed:match("%d+"))
						end
						self.inputText:SetWidth(self.inputText:GetFullWidth())
					elseif self.index == 19 then
						if not typed == "" then
							powerBuffs[role][barId] = typed
						end
						self.inputText:SetWidth(self.inputText:GetFullWidth())
					elseif self.index == 20 then
						local rgb = {}
						for token in string.gmatch(typed,"[^ ]+") do
							table.insert(rgb,tonumber(token))
						end
						barStats[role][barId]["barColor"] = rgb
						self.inputText:SetWidth(self.inputText:GetFullWidth())
					end

				end
				typeStack = {}
				fullRefresh = true
			end
			function bar.Event:RightDown()
				print(self.index)
				if powergui.rightdown == false then
					if debugmode then print(self.index) end
					self:SetKeyFocus(true)
					if self.index >= 1 then
						barindex = self.index
						powergui.rightdown = true
					else
						gui = true
						powergui.rightdown = true
					end
				end
			end
			if bar.riftwindow then
			    print(self.index)
			    function bar.riftwindow.Event:LeftDown()
					print("hmmm")
				    if powergui.rightdown == false then
				    	if powergui.debugmode then print(self.index)end
				    	self:SetKeyFocus(true)
				    	if self.index >= 1 then
				    		barindex = self.index
				    		powergui.rightdown = true
				    	else
				    		gui = true
				    		powergui.rightdown = true
				    	end
				    end
				end

			end

			function bar.Event:RightUp()
				powergui.rightdown = false
			end
			function bar.Event:RightUpoutside()
				powergui.rightdown = false
				self:SetKeyFocus(false)
			end
			function bar.Event:MouseMove(x,y)
				if powergui.rightdown and moveBuffs and self.index > 1 then
-- 					guiPos[barindex][1] = -guiPos[1][1] + x
-- 					guiPos[barindex][2] = -guiPos[1][2] + y
-- 					fullRefresh = true
				elseif 	 powergui.rightdown and moveBuffs and self.index == 1 then
				    guiPos[barindex][1] = x
					guiPos[barindex][2] = y
					fullRefresh = true
				end
			end
        elseif i == 19 then
            function bar.inputBarId.Event:TextfieldChange()

                powerBuffs[role][barId] = self:GetText()
            end

		end
	  	bar:Set(Inspect.Time.Frame())
	  	if not gui then self:SetVisible(false)
		else self:SetVisible(true)end
	end

	table.insert(activeBuffBars,i,bar)
end


--create buttons

bar = UI.CreateFrame("Frame", "Bar", context)
bar.index = 21
bar:SetMouseMasking("limited")
if bar.index == 21 then
	bar.inputBarId = UI.CreateFrame("RiftButton", "Input", bar)
	bar.inputBarId:SetPoint(0,0,bar,0,0)
	bar.inputBarId:SetPoint(1,1,bar,1,1)
	--bar.inputBarId:SetBackgroundColor(.8,.8,.8)
	bar:SetPoint(0,0, activeBuffBars[1], 0,0,guiPos[bar.index][1],guiPos[bar.index][2])
	bar:SetLayer(1)
	bar.inputText = UI.CreateFrame("Text","inputText",bar)
	bar.inputBarId:SetText("Move Buffs")
	bar.inputText:SetWidth(bar.inputText:GetFullWidth())
	bar.inputText:SetFontSize(22)
	bar.inputText:SetFontColor(0,0,0)
	bar.inputText:SetPoint(0,0,bar.inputBarId,.02,0,0,0)
	bar.inputText:SetLayer(2)
end
bar:SetWidth(guiDim[bar.index][1])
bar:SetHeight(guiDim[bar.index][2])

if i == 1 then
	bar:SetBackgroundColor(0.2, 0.2, 0.6)
	bar:SetLayer(0)
end
if not gui then bar:SetVisible(false)
else bar:SetVisible(true)end

function bar:Tick(time)
	if self.index == 21 then
		function bar.Event:RightDown()
			if moveBuffs then
				moveBuffs = false
				self.inputText:SetText("Move Buffs")
				self.inputText:SetWidth(self.inputText:GetFullWidth())
			else
				moveBuffs = true
				self.inputText:SetText("Stop Moving Buffs")
				self.inputText:SetWidth(self.inputText:GetFullWidth())
			end
		end
		function bar.inputBarId.Event:LeftPress()
			if moveBuffs then
				moveBuffs = false
				self:SetText("Move Buffs")
				--self:SetWidth(self:GetFullWidth())
			else
				moveBuffs = true
				self:SetText("Stop Moving")
				--self:SetWidth(self:GetFullWidth())
			end
		end

	end

	if not gui then self:SetVisible(false)
	else self:SetVisible(true)end
end

table.insert(activeBuffBars,bar.index,bar)

local barClose = UI.CreateFrame("Frame", "Bar", context)
barClose.index = 22
barClose:SetMouseMasking("limited")
if barClose.index == 22 then
	barClose.inputBarId = UI.CreateFrame("RiftButton", "Input", barClose)
	barClose.inputBarId:SetPoint(0,0,barClose,0,0)
	barClose.inputBarId:SetPoint(1,1,barClose,1,1)
	--barClose.inputBarId:SetBackgroundColor(.8,.8,.8)
	barClose:SetPoint(0,0, activeBuffBars[1], 0,0,guiPos[barClose.index][1],guiPos[barClose.index][2])
	barClose:SetLayer(1)
	barClose.inputText = UI.CreateFrame("Text","inputText",barClose)
	barClose.inputBarId:SetText("Close")
	barClose.inputText:SetFontSize(22)
	barClose.inputText:SetFontColor(0,0,0)
	barClose.inputText:SetPoint(0,0,barClose.inputBarId,.05,0,0,0)
	barClose.inputText:SetLayer(2)
end
barClose:SetWidth(125)
barClose:SetHeight(guiDim[22][2])

if i == 1 then
	--barClose:SetBackgroundColor(0.2, 0.2, 0.6)
	barClose:SetLayer(0)
end
if not gui then barClose:SetVisible(false)
else barClose:SetVisible(true)end

function barClose:Tick(time)
	if self.index == 22 then
		function barClose.Event:RightDown()
			if gui then
				gui = false
				fullRefresh = true
			else
			    gui = true
				fullRefresh = true
			end
		end
		function barClose.inputBarId.Event:LeftPress()
			if gui then
				gui = false
				fullRefresh = true
			else
			    gui = true
				fullRefresh = true
			end
		end

	end

	if not gui then self:SetVisible(false)
	else self:SetVisible(true)end
end

table.insert(activeBuffBars,barClose.index,barClose)



local function movegui(commandline)
	if commandline == "off" then
		gui = false
		fullRefresh = true
	elseif commandline == "" then
		print("powermovebuffs status\nStatus: on or off")
		print("Currently, this is buggy due to mouse events and has been disabled. /powermb is recommended")
	elseif commandline == "on" then
		gui = true
		fullRefresh = true
	end
end


local function tick()
	if fullRefresh then
		local time = Inspect.Time.Frame()
		for i = 1,table.maxn(activeBuffBars)  do
		  activeBuffBars[i]:Tick(time)
		end
		fullRefresh = false
    end
end

-- Our update event. This triggers every single frame.
table.insert(Event.System.Update.Begin, {tick, "PowerBuffs", "refresh"})

table.insert(Command.Slash.Register("powergui"), {movegui, "PowerBuffs", "Move Buffs"})
